var AcccPortal =  AcccPortal || {};

AcccPortal.Constants = {
    OutComes: {
        InProgress: "In-progress",
        Errored: "Errored",
        VirusFound: "VirusFound",
        ValidationFail: "ValidationFail",
        ValidationWarning: "Warning",
        ErrorAndWarning: "ErrorAndWarning",
        ErrorWithVirusFound: "ErrorWithVirusFound",
        Completed: "Completed",
        NoFileFound: "NoFileFound",
    },
    DisplayActionsforVirus: {
        NoFileFound: "NoFileFound",
        AllFilePass: "AllFilePass",
        ErrorWithVirusFound: "ErrorWithVirusFound",
        ErrorFound: "ErrorFound",
        VirusFound: "VirusFound",
        ErrorAndWarning: "ErrorAndWarning",
        InProgress: "InProgress",
        Initialization: "Initialization",
    },
    DisplayActionsforValidation: {
        Initialization: "ValidationInitialization",
        InProgress: "ValidationInProgress",
        AllFilePass: "ValidationAllFilePass",
        ValidationFail: "ValidationFail",
        Warning: "ValidationWarning",
        ErrorFound: "ValidationErrorFound",
        ErrorAndWarning: "ValidationErrorAndWarning",

    },
    VirusScanOptionSets: {
        Pending: 809920000,
        InProgress: 809920001,
        Pass: 809920002,
        Errored: 809920003,
        Fail: 809920004
    },

    ValidationScanOptionSets: {
        Pending: 809920000,
        InProgress: 809920001,
        Pass: 809920002,
        Errored: 809920003,
        Fail: 809920004,
        Warning: 809920005,
        ErrorAndWarning: 809920006
    },
    AttributeClasses: {
        DecimalOnlyWith2Places: "decimal-2-places-only-field",
        DecimalMaxValClassPrefix: "decimal-field-max-",
        NumbersOnly: "number-only-field",
        NumbersMaxValClassPrefix: "number-field-max-",
    },
    FieldTypes: {
        TextArea: "TEXTAREA",
        Input: "INPUT"
    }
};

AcccPortal.Common = (function () {
    
   var _safeAjax = function setupSafeAjax(ajaxOptions) {
        var deferredAjax = $.Deferred();

        shell.getTokenDeferred().done(function (token) {
            // add headers for AJAX
            if (!ajaxOptions.headers) {
                $.extend(ajaxOptions, {
                    headers: {
                        "__RequestVerificationToken": token
                    }
                });
            } else {
                ajaxOptions.headers["__RequestVerificationToken"] = token;
            }
            $.ajax(ajaxOptions)
                .done(function (data, textStatus, jqXHR) {
                    validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                }).fail(deferredAjax.reject); //AJAX
        }).fail(function () {
            deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
        });

        return deferredAjax.promise();
    };
    var _timer = function (interval, triggerpromises) {
        var _this;
        this.timerId = 0;
        this.interval = interval;
        this.enable = false;
        this.tickcompleted;
        this.triggerpromises = triggerpromises;

        this.start = function () {
            if ($('#hndTimmerId')) {
                clearInterval($('#hndTimmerId').val());
            }
            this.enable = true;
            _this = this;

            if (_this.enable) {
                _this.timerId = setInterval(
                    function () {
                        Promise.all(_this.triggerpromises)
                            .then((response) => {
                                console.log(response);
                                _this.tickcompleted(response);
                            })
                            .catch((response) => {
                                console.log(response);
                                _this.tickcompleted(response);
                            });
                    }
                    , _this.interval);

                if ($('#hndTimmerId')) {
                    $('#hndTimmerId').val(_this.timerId);
                }
                else {
                    $('<input>').attr({
                        type: 'hidden',
                        id: 'hndTimmerId',
                        name: 'TimmerId',
                        value: _this.timerId,
                    }).appendTo('body');
                }
            }
        };

        this.stop = function () {
            _this.enable = false;
            clearInterval(_this.timerId);
        };
    };

    var _notification = function (messageCtrlId, defaultmsg) {
        var $processingMsgEl = $(messageCtrlId),
            _msg = defaultmsg,
            _stack = 0,
            _endTimeout;

        this.show = function (msg) {
            $processingMsgEl.text(msg || _msg);
            if (_stack === 0) {
                clearTimeout(_endTimeout);
                $processingMsgEl.show();
            }
            _stack++;
        };

        this.hide = function () {
            _stack--;
            if (_stack <= 0) {
                _stack = 0;
                clearTimeout(_endTimeout);
                _endTimeout = setTimeout(function () {
                    $processingMsgEl.hide();
                }, 500);
            }
        };
    };

    var _table = function (config) {

        this.tableElement = config.tableElement;
        this.notificationControlId = config.notificationControlId,
            this.renderMode = config.renderMode; //'create', 'update'
        this.columns = config.columns;
        this.data = config.data;
        this.keyAttribute = config.keyAttribute;
        this.messages = config.messages;
        var trTpl = '<% _.forEach(data, function(data){ %>' +
            '<tr>' +
            '<% _.forEach(columns, function(col){ %>' +
            '<td data-attribute="<%=col.name%>" data-label="<%=col.label%>" data-value="<%=data[col.name]%>">' +
            '<%-data[col.name]%>' +
            '</td>' +
            '<% }) %>' +
            '</tr>' +
            '<% }) %>';

        var tableTpl = '<table class="table table-hover">' +
            '<thead>' +
            '<tr>' +
            '<% _.forEach(columns, function(col){ %>' +
            '<th class="<%=col.cssclass%>"><%=col.label%></th>' +
            '<% }) %>' +
            '</tr>' +
            '</thead>' +
            '<tbody>' + trTpl + '</tbody>' +
            '</table>';

        function getDataObject(rowEl) {
            var $rowEl = $(rowEl),
                attrObj = {
                    id: $rowEl.attr('data-id'),
                    name: $rowEl.attr('data-name')
                };

            $rowEl.find('td').each(function (i, el) {
                var $el = $(el), key = $el.attr('data-attribute');
                if (key) {
                    var dataType = $el.attr('data-type');
                    var dataValue = $el.attr('data-value');

                    if (dataValue && dataType === 'Microsoft.Xrm.Sdk.OptionSetValue') {
                        attrObj[key] = JSON.parse(dataValue).Value;
                    }
                    else {
                        attrObj[key] = dataValue;
                    }
                }
            });

            return attrObj;
        };

        function bindRowEvents(tr, config) {
            var $row = $(tr), dataObj = getDataObject($row);
            var id = $row[0].dataset.id;
            $.each(config.columns, function (i, col) {
                var $el = $row.find('td[data-attribute="' + col.name + '"]');
                switch (col.display) {
                    case "css":
                        var value = dataObj[col.name];
                        let optionsetmap = col.optionsetmaps.find(map => map.value.toString() === value.toString());

                        if (optionsetmap) {
                            if (optionsetmap.isLink == true && optionsetmap.function != "") {
                                $el.html("");
                                $el.addClass(col.cssclass);
                                $el.append(`<a href='javascript:${optionsetmap.function.name}("${id}")' ><span class="${optionsetmap.cssclass}" style="${optionsetmap.cssstyle}"></span></a>`);
                            }
                            else {
                                $el.html("");
                                $el.addClass(col.cssclass);
                                $el.append(`<span class="${optionsetmap.cssclass}" style="${optionsetmap.cssstyle}"></span>`);
                            }
                        }
                        break;
                }
            });
        };

        function updateRows(tr, config) {
            if (config.data) {
                var $row = $(tr);
                var id = $row.attr('data-id');

                if (config.keyAttribute) {
                    var record = config.data.find(r => r[config.keyAttribute].toString() == id.toString());

                    $.each(config.columns, function (i, col) {
                        let $el = $row.find('td[data-attribute="' + col.name + '"]');
                        if (col.optionsetmaps) {
                            var json = {
                                Value: record[col.name],
                                ExtensionData: null
                            }
                            $el.attr('data-value', JSON.stringify(json));
                            $el.html(record[col.name + '@OData.Community.Display.V1.FormattedValue']);
                        } else {
                            $el.attr('data-value', record[col.name]);
                            $el.html(record[col.name]);
                        }
                    });
                }
            }
        };

        function bindTableEvents($table, config) {
            $table.find('tbody tr').each(function (i, tr) {
                updateRows(tr, config);
                bindRowEvents(tr, config);
            });
        };

        this.render = function (el) {
            var $table = $(el);

            if (typeof this.renderMode === 'undefined' || this.renderMode !== 'update') {
                $table.html(_.template(tableTpl)({
                    columns: this.columns,
                    data: this.data
                })).find('table');
            }

            bindTableEvents($table, {
                columns: this.columns,
                keyAttribute: this.keyAttribute,
                data: this.data
            });
        };
    };

    var _helper = function () {

        this.formatCurrentDate = function (format) {
            return this.formatDate(new Date(), format);
        };

        this.formatDate = function (date, format) {
            date.add(2).hours();  //to add time to compensate for timezone offset
            return date.format(format); //format :: EDM FORMAT='yyyy-MM-ddTHH:mm:ss'
        };

        this.clearTableCssColums = function (table) {
            var $_thistable = $(table.tableElement);

            $_thistable.find('tbody tr').each(function (i, tr) {
                var $row = $(tr);

                $.each(table.columns, function (i, col) {
                    if (col.display === 'css') {
                        let $el = $row.find('td[data-attribute="' + col.name + '"]');
                        $el.html('...');
                    }
                });
            });
        };

        this.renderTable = function (table, ajaxOptions) {
            var _thistable = table;
            console.log(ajaxOptions.url);

            return new Promise((resolve, reject) => {
                var ajaxApiRequest = new AcccPortal.WebApi.AjaxApiRequest();
                ajaxApiRequest.safeAjax(ajaxOptions)
                    .fail(function (response) {
                        reject(response);
                    })
                    .done(function (response) {
                        _thistable.data = _.map(JSON.parse(response).value, function (record) {
                            return record;
                        });
                        _thistable.render(_thistable.tableElement);
                        resolve(_thistable);
                    });
            });
        };

        this.retrieveData = function (ajaxOptions) {
            var ajaxApiRequest = new AcccPortal.WebApi.AjaxApiRequest();

            return new Promise((resolve, reject) => {
                ajaxApiRequest.safeAjax(ajaxOptions)
                    .fail(function (response) {
                        reject(response);
                    })
                    .done(function (response) {
                        resolve(JSON.parse(response).value);
                    });
            });
        };

        this.checkRenderTableResponse = function checkresponse(responses, statusAttribute) {
            var status = {
                "Outcome": AcccPortal.Constants.OutComes.Errored,
                "tableKey": null
            };
            if (responses && Array.isArray(responses)) {
                $.each(responses, function (i, response) {
                    let inProgressrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.VirusScanOptionSets.Pending || record[statusAttribute] == AcccPortal.Constants.VirusScanOptionSets.InProgress);
                    if (inProgressrows.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.InProgress,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }

                    let inVirusedrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.VirusScanOptionSets.Fail);
                    let inErroredrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.VirusScanOptionSets.Errored);

                    if (inVirusedrows.length > 0 && inErroredrows.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.ErrorWithVirusFound,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }
                    else if (inVirusedrows.length > 0 && inErroredrows.length == 0) {

                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.VirusFound,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }
                    else if (inErroredrows.length > 0 && inVirusedrows.length == 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.Errored,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }

                    let inPassrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.VirusScanOptionSets.Pass);
                    if (inPassrows.length == response.data.length && response.data.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.Completed,
                            "tableKey": response.keyAttribute
                        };
                    }
                    else {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.NoFileFound,
                            "tableKey": response.keyAttribute
                        };
                    }
                });
            }

            return status;
        };


        this.checkRenderTableValidationResponse = function checkresponse(responses, statusAttribute) {
            var status = {
                "Outcome": AcccPortal.Constants.OutComes.Errored,
                "tableKey": null
            };
            if (responses && Array.isArray(responses)) {
                $.each(responses, function (i, response) {
                    let inProgressrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.Pending || record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.InProgress);
                    if (inProgressrows.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.InProgress,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }

                    let inValidationFailrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.Fail);
                    let inErroredrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.Errored);
                    let inWarningrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.Warning);
                    if (inValidationFailrows.length > 0 && inErroredrows.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.Errored,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }
                    else if (inValidationFailrows.length > 0 && inErroredrows.length == 0) {

                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.ValidationFail,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }
                    else if (inErroredrows.length > 0 && inValidationFailrows.length == 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.Errored,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }
                    else if (inWarningrows.length > 0 && inValidationFailrows.length == 0 && inErroredrows.length == 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.ValidationWarning,
                            "tableKey": response.keyAttribute
                        };
                        return false;
                    }

                    let inPassrows = response.data.filter(record => record[statusAttribute] == AcccPortal.Constants.ValidationScanOptionSets.Pass);
                    if (inPassrows.length == response.data.length && response.data.length > 0) {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.Completed,
                            "tableKey": response.keyAttribute
                        };
                    }
                    else {
                        status = {
                            "Outcome": AcccPortal.Constants.OutComes.NoFileFound,
                            "tableKey": response.keyAttribute
                        };
                    }
                });
            }

            return status;
        };

        this.validateDocuments = function (validatorId, validationMessage, validator) {
            try {
                var Requiredvalidator = document.createElement('span');
                Requiredvalidator.style.display = "none";
                Requiredvalidator.id = validatorId;
                Requiredvalidator.controltovalidate = validatorId + "_Control";
                Requiredvalidator.errormessage = `<a href='#${validatorId}'>${validationMessage}</a>`;
                Requiredvalidator.initialvalue = "";
                Requiredvalidator.evaluationfunction = function () {
                    var isDocumentAssociated = validator();
                    if (isDocumentAssociated == false) {
                        return false;
                    } else {
                        return true;
                    }
                };

                // Add the new validator to the page validators array:
                Page_Validators.push(Requiredvalidator);
            }
            catch (error) {
                errorHandler(error);
            }
        };

        this.removeValidatior = function (validatorId) {
            try {
                for (i = 0; i <= Page_Validators.length - 1; i++) {
                    if (Page_Validators[i].id == validatorId) {
                        Page_Validators.splice(i);
                    }
                }
            }
            catch (error) {
                errorHandler(error);
            }
        };

        this.displayDocumentValidationMessage = function (table, action) {
            var notificationControl = $(table.notificationControlId);
            if (notificationControl) {
                notificationControl.html('');
                notificationControl.hide();

                var messageMap = table.messages.find(map => map.action == action);
                if (messageMap && messageMap.message) {
                    notificationControl.html($('<div/>').html(messageMap.message).text());
                    notificationControl.show();
                }
            }
        };

        this.formatString = function (str, formatArgs) {
            for (var p in formatArgs) {
                str = str.replace(new RegExp('{' + p + '}', 'g'), formatArgs[p]);
            }
            return str;
        };

        this.clearSupportingDocumentChecklist = function (supportingDocumentCheckList) {

            if ($(supportingDocumentCheckList).find(".view-grid .table tbody tr td:last-child ul.dropdown-menu > li > a.edit-link").length > 0) {
                var trs = $(supportingDocumentCheckList).find(".view-grid .table tbody tr");
                $.each(trs, function (index, tr) {
                    var id = tr.attributes["data-id"].value;
                    var row = $(tr).find("td:last-child");
                    if ($(tr).find("td[data-attribute='accc_fileuploaded']").length > 0) {
                        $(tr).find("td[data-attribute='accc_fileuploaded'] time").remove();
                        $(row).find("button").show();
                    }
                });
            }
        };

        this.hideAndShowUploadFileforSupportingChecklist = function (tablerows, dataPageurl, recordId, entityFormId, refentity, refrel) {

            $.each(tablerows, function (index, tr) {
                var id = tr.attributes["data-id"].value;
                var row = $(tr).find("td:last-child");
                var isAllowedMultiple = $(tr).find("td[data-attribute='accc_allowadditionaldocuments']")[0].dataset.value;
                var actions = $(row).find("ul.dropdown-menu > li > a.edit-link");

                if ($(tr).find("td[data-attribute='accc_fileuploaded']").length == 0) {
                    $(actions).attr("href", "javascript:AcccPortal.FormHelper.loadEntityFormAsModal('Create','" + dataPageurl + "','" + recordId + "','" + entityFormId + "' ,'" + refentity + "','" + refrel + "','" + id + "','supportDocumentUploadDialog');");
                }
                else if ($(tr).find("td[data-attribute='accc_fileuploaded']").length > 0 && isAllowedMultiple == "true") {
                    $(actions).attr("href", "javascript:AcccPortal.FormHelper.loadEntityFormAsModal('Create','" + dataPageurl + "','" + recordId + "','" + entityFormId + "' ,'" + refentity + "','" + refrel + "','" + id + "','supportDocumentUploadDialog');");
                }
                else {
                    $(actions).attr("href", "javascript:AcccPortal.FormHelper.loadEntityFormAsModal('Create','" + dataPageurl + "','" + recordId + "','" + entityFormId + "' ,'" + refentity + "','" + refrel + "','" + id + "','supportDocumentUploadDialog');");
                    $(row).find("button").hide();
                }

            });
        };
        this.clearUploadedTimestempAllowUploadAgain = function (tablerows, result) {

            $.each(tablerows, function (index, tr) {
                var id = tr.attributes["data-id"].value;
                if ($.inArray(id, result) != -1) {
                }
                else {
                    var row = $(tr).find("td:last-child");
                    if ($(tr).find("td[data-attribute='accc_fileuploaded']").length > 0) {
                        $(tr).find("td[data-attribute='accc_fileuploaded'] time").remove();
                        $(row).find("button").show();
                    }
                }
            });
        };

        this.populatedSupportingDocumentsAlreadyUploaded = function (tablerows, result) {

            $.each(tablerows, function (index, tr) {
                if (!result.join('##').match(JSON.parse($(tr).find("td[data-attribute='accc_supportingdocument']")[0].dataset.value).Id)) {
                    result.push(JSON.parse($(tr).find("td[data-attribute='accc_supportingdocument']")[0].dataset.value).Id);
                }
            });

            return result;
        };


        this.clearDataDocumentChecklist = function (documentCheckList) 
        {
        if ($(documentCheckList).find(".view-grid .table tbody tr td:last-child ul.dropdown-menu > li > a.edit-link").length > 0) {
            var trs = $(documentCheckList).find(".view-grid .table tbody tr");
            $.each(trs, function (index, tr) {
                var id = tr.attributes["data-id"].value;
                var row = $(tr).find("td:last-child");
                if ($(tr).find("td[data-attribute='accc_fileuploadedon']").length > 0) {
                    $(tr).find("td[data-attribute='accc_fileuploadedon'] time").remove();
                    $(row).find("button").show();
                }
            });
        }
        };
            
        this.clearUploadedTimestempAllowUploadAgainDataDocument = function(tablerows, result) {
        
        $.each(tablerows, function (index, tr) {
            var id = tr.attributes["data-id"].value;
            if ($.inArray(id, result) != -1) {
                var row = $(tr).find("td:last-child");
                if ($(tr).find("td[data-attribute='accc_fileuploadedon']").length > 0) {
                    $(row).find("button").hide();
                }
            }
            else {
                var row = $(tr).find("td:last-child");
                if ($(tr).find("td[data-attribute='accc_fileuploadedon']").length > 0) {
                    $(tr).find("td[data-attribute='accc_fileuploadedon'] time").remove();
                    $(row).find("button").show();
                }
            }
        });
        };
        
        this.populatedDataDocumentsAlreadyUploaded  = function(tablerows, result) {
        
        $.each(tablerows, function (index, tr) {
            if (!result.join('##').match(tr.attributes["data-id"].value)) {
                result.push(tr.attributes["data-id"].value);
            }
        });
        
        return result;
        };
           


        this.populateSupportingDocument = function (id, url, control) {
            var helper = new AcccPortal.Common.Helper();
            $.getJSON(url, function (data) {
                if (data.results.length > 0) {
                    data.results.forEach(element => {
                        let option = document.createElement("option");
                        option.value = element.id;
                        option.innerText = element.name;
                        $("#"+ control).append(option);
                    });

                    $("#"+ control).prepend("<option value='00000000-0000-0000-0000-000000000000' selected='selected'>Show All</option>");
                }
                else {
                    $("#"+control).closest("tr").hide();
                }
            }
            );
        };

        this.filterDocumentTypeGrid = function (supportingDocumentChecklists, control, attribute) {
            if ($(supportingDocumentChecklists).find(".view-grid .table tbody tr").length > 0) {
                var trs = $(supportingDocumentChecklists).find(".view-grid .table tbody tr");
                $.each(trs, function (index, tr) {

                    if ($(tr).find("td[data-attribute='"+ attribute +"']").length > 0) {
                        if ($('#'+ control).val() == "00000000-0000-0000-0000-000000000000") {
                            $(tr).show();

                        }
                        else if (JSON.parse($(tr).find("td[data-attribute='"+ attribute +"']")[0].dataset.value).Id == $('#' +control).val()) {
                            $(tr).show();

                        }
                        else {
                            $(tr).hide();
                        }

                    }
                });
            }
        };
    };

    var _ui = function () {

    };

    return {
        Helper: _helper,
        Table: _table,
        Notification: _notification,
        Timer: _timer,
        UI: _ui,
        safeAjax: _safeAjax,
    };
})();
